Xerces-C++: XercesDOMParser Class Reference

Xerces-C++ 3.2.4

List of all members
XercesDOMParser Class Reference

This class implements the Document Object Model (DOM) interface. More...

`#include <xercesc/parsers/XercesDOMParser.hpp>`

Inheritance diagram for XercesDOMParser:

## Public Member Functions
Constructors and Destructor
| XercesDOMParser (XMLValidator *const valToAdopt=0, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager, XMLGrammarPool *const gramPool=0)
| Construct a XercesDOMParser, with an optional validator. More...
virtual | ~XercesDOMParser ()
| Destructor. More...
Getter methods
ErrorHandler * | getErrorHandler ()
| Get a pointer to the error handler. More...
const ErrorHandler * | getErrorHandler () const
| Get a const pointer to the error handler. More...
EntityResolver * | getEntityResolver ()
| Get a pointer to the entity resolver. More...
const EntityResolver * | getEntityResolver () const
| Get a const pointer to the entity resolver. More...
XMLEntityResolver * | getXMLEntityResolver ()
| Get a pointer to the entity resolver. More...
const XMLEntityResolver * | getXMLEntityResolver () const
| Get a const pointer to the entity resolver. More...
bool | isCachingGrammarFromParse () const
| Get the 'Grammar caching' flag. More...
bool | isUsingCachedGrammarInParse () const
| Get the 'Use cached grammar' flag. More...
Grammar * | getGrammar (const XMLCh *const nameSpaceKey)
| Retrieve the grammar that is associated with the specified namespace key. More...
Grammar * | getRootGrammar ()
| Retrieve the grammar where the root element is declared. More...
const XMLCh * | getURIText (unsigned int uriId) const
| Returns the string corresponding to a URI id from the URI string pool. More...
XMLFilePos | getSrcOffset () const
| Returns the current src offset within the input source. More...
bool | getIgnoreCachedDTD () const
| Get the 'ignore cached DTD grammar' flag. More...
Setter methods
void | setErrorHandler (ErrorHandler *const handler)
| Set the error handler. More...
void | setEntityResolver (EntityResolver *const handler)
| Set the entity resolver. More...
void | setXMLEntityResolver (XMLEntityResolver *const handler)
| Set the entity resolver. More...
void | cacheGrammarFromParse (const bool newState)
| Set the 'Grammar caching' flag. More...
void | useCachedGrammarInParse (const bool newState)
| Set the 'Use cached grammar' flag. More...
void | setIgnoreCachedDTD (const bool newValue)
| Set the 'ignore cached DTD grammar' flag. More...
Utility methods
void | resetDocumentPool ()
| Reset the documents vector pool and release all the associated memory back to the system. More...
Implementation of the XMLErrorReporter interface.
virtual void | error (const unsigned int errCode, const XMLCh *const msgDomain, const XMLErrorReporter::ErrTypes errType, const XMLCh *const errorText, const XMLCh *const systemId, const XMLCh *const publicId, const XMLFileLoc lineNum, const XMLFileLoc colNum)
| Handle errors reported from the parser. More...
virtual void | resetErrors ()
| Reset any error data before a new parse. More...
Implementation of the XMLEntityHandler interface.
virtual void | endInputSource (const InputSource &inputSource)
| Handle an end of input source event. More...
virtual bool | expandSystemId (const XMLCh *const systemId, XMLBuffer &toFill)
| Expand a system id. More...
virtual void | resetEntities ()
| Reset any entity handler information. More...
virtual InputSource * | resolveEntity (XMLResourceIdentifier *resourceIdentifier)
| Resolve a public/system id. More...
virtual void | startInputSource (const InputSource &inputSource)
| Handle a 'start input source' event. More...
Public Member Functions inherited from AbstractDOMParser
virtual | ~AbstractDOMParser ()
| Destructor. More...
void | reset ()
| Reset the parser. More...
DOMDocument * | adoptDocument ()
| Adopt the DOM document. More...
DOMDocument * | getDocument ()
| Get the DOM document. More...
const XMLValidator & | getValidator () const
| Get a const reference to the validator. More...
ValSchemes | getValidationScheme () const
| This method returns an enumerated value that indicates the current validation scheme set on this parser. More...
bool | getDoSchema () const
| Get the 'do schema' flag. More...
bool | getValidationSchemaFullChecking () const
| Get the 'full schema constraint checking' flag. More...
bool | getIdentityConstraintChecking () const
| Get the identity constraint checking' flag. More...
XMLSize_t | getErrorCount () const
| Get error count from the last parse operation. More...
bool | getDoNamespaces () const
| Get the 'do namespaces' flag. More...
bool | getExitOnFirstFatalError () const
| Get the 'exit on first error' flag. More...
bool | getValidationConstraintFatal () const
| This method returns the state of the parser's validation-constraint-fatal flag. More...
bool | getCreateEntityReferenceNodes () const
| Get the 'include entity references' flag. More...
bool | getIncludeIgnorableWhitespace () const
| Get the 'include ignorable whitespace' flag. More...
XMLCh * | getExternalSchemaLocation () const
| Get the set of Namespace/SchemaLocation that is specified externally. More...
XMLCh * | getExternalNoNamespaceSchemaLocation () const
| Get the noNamespace SchemaLocation that is specified externally. More...
SecurityManager * | getSecurityManager () const
| Get the SecurityManager instance attached to this parser. More...
const XMLSize_t & | getLowWaterMark () const
| Get the raw buffer low water mark for this parser. More...
bool | getLoadExternalDTD () const
| Get the 'Loading External DTD' flag. More...
bool | getLoadSchema () const
| Get the 'Loading Schema' flag. More...
bool | getCreateCommentNodes () const
| Get the 'create comment node' flag. More...
bool | getCalculateSrcOfs () const
| Get the 'calculate src offset flag'. More...
bool | getStandardUriConformant () const
| Get the 'force standard uri flag'. More...
PSVIHandler * | getPSVIHandler ()
| This method returns the installed PSVI handler. More...
const PSVIHandler * | getPSVIHandler () const
| This method returns the installed PSVI handler. More...
bool | getCreateSchemaInfo () const
| Get the 'associate schema info' flag. More...
bool | getDoXInclude () const
| Get the 'do XInclude' flag. More...
bool | getGenerateSyntheticAnnotations () const
| Get the 'generate synthetic annotations' flag. More...
bool | getValidateAnnotations () const
| Get the 'validate annotations' flag. More...
bool | getIgnoreAnnotations () const
| Get the 'ignore annotations' flag. More...
bool | getDisableDefaultEntityResolution () const
| Get the 'disable default entity resolution' flag. More...
bool | getSkipDTDValidation () const
| Get the 'skip DTD validation' flag. More...
bool | getHandleMultipleImports () const
| Get the 'handle multiple schema imports' flag. More...
void | setGenerateSyntheticAnnotations (const bool newValue)
| set the 'generate synthetic annotations' flag More...
void | setValidateAnnotations (const bool newValue)
| set the 'validlate annotations' flag More...
void | setDoNamespaces (const bool newState)
| Set the 'do namespaces' flag. More...
void | setExitOnFirstFatalError (const bool newState)
| Set the 'exit on first error' flag. More...
void | setValidationConstraintFatal (const bool newState)
| This method allows users to set the parser's behaviour when it encounters a validation constraint error. More...
void | setCreateEntityReferenceNodes (const bool create)
| Set the 'include entity references' flag. More...
void | setIncludeIgnorableWhitespace (const bool include)
| Set the 'include ignorable whitespace' flag. More...
void | setValidationScheme (const ValSchemes newScheme)
| This method allows users to set the validation scheme to be used by this parser. More...
void | setDoSchema (const bool newState)
| Set the 'do schema' flag. More...
void | setValidationSchemaFullChecking (const bool schemaFullChecking)
| This method allows the user to turn full Schema constraint checking on/off. More...
void | setIdentityConstraintChecking (const bool newState)
| This method allows users to enable or disable the parser's identity constraint checks. More...
void | setExternalSchemaLocation (const XMLCh *const schemaLocation)
| This method allows the user to specify a list of schemas to use. More...
void | setExternalSchemaLocation (const char *const schemaLocation)
| This method is same as setExternalSchemaLocation(const XMLCh* const). More...
void | setExternalNoNamespaceSchemaLocation (const XMLCh *const noNamespaceSchemaLocation)
| This method allows the user to specify the no target namespace XML Schema Location externally. More...
void | setExternalNoNamespaceSchemaLocation (const char *const noNamespaceSchemaLocation)
| This method is same as setExternalNoNamespaceSchemaLocation(const XMLCh* const). More...
void | setSecurityManager (SecurityManager *const securityManager)
| This allows an application to set a SecurityManager on the parser; this object stores information that various components use to limit their consumption of system resources while processing documents. More...
void | setLowWaterMark (XMLSize_t lwm)
| Set the raw buffer low water mark for this parser. More...
void | setLoadExternalDTD (const bool newState)
| Set the 'Loading External DTD' flag. More...
void | setLoadSchema (const bool newState)
| Set the 'Loading Schema' flag. More...
void | setCreateCommentNodes (const bool create)
| Set the 'create comment nodes' flag. More...
void | setCalculateSrcOfs (const bool newState)
| Enable/disable src offset calculation. More...
void | setStandardUriConformant (const bool newState)
| Force standard uri. More...
void | useScanner (const XMLCh *const scannerName)
| Set the scanner to use when scanning the XML document. More...
void | useImplementation (const XMLCh *const implementationFeatures)
| Set the implementation to use when creating the document. More...
virtual void | setPSVIHandler (PSVIHandler *const handler)
| This method installs the user specified PSVI handler on the parser. More...
void | setCreateSchemaInfo (const bool newState)
| Set the 'associate schema info' flag. More...
void | setDoXInclude (const bool newState)
| Set the 'do XInclude' flag. More...
void | setIgnoreAnnotations (const bool newValue)
| Set the 'ignore annotation' flag. More...
void | setDisableDefaultEntityResolution (const bool newValue)
| Set the 'disable default entity resolution' flag. More...
void | setSkipDTDValidation (const bool newValue)
| Set the 'skip DTD validation' flag. More...
void | setHandleMultipleImports (const bool newValue)
| Set the 'handle multiple schema imports' flag. More...
void | parse (const InputSource &source)
| Parse via an input source object. More...
void | parse (const XMLCh *const systemId)
| Parse via a file path or URL. More...
void | parse (const char *const systemId)
| Parse via a file path or URL (in the local code page) More...
bool | parseFirst (const XMLCh *const systemId, XMLPScanToken &toFill)
| Begin a progressive parse operation. More...
bool | parseFirst (const char *const systemId, XMLPScanToken &toFill)
| Begin a progressive parse operation. More...
bool | parseFirst (const InputSource &source, XMLPScanToken &toFill)
| Begin a progressive parse operation. More...
bool | parseNext (XMLPScanToken &token)
| Continue a progressive parse operation. More...
void | parseReset (XMLPScanToken &token)
| Reset the parser after a progressive parse. More...
virtual void | handleElementPSVI (const XMLCh *const localName, const XMLCh *const uri, PSVIElement *elementInfo)
| Receive notification of the PSVI properties of an element. More...
virtual void | handlePartialElementPSVI (const XMLCh *const localName, const XMLCh *const uri, PSVIElement *elementInfo)
| Receive notification of partial PSVI properties of an element. More...
virtual void | handleAttributesPSVI (const XMLCh *const localName, const XMLCh *const uri, PSVIAttributeList *psviAttributes)
| Enables PSVI information about attributes to be passed back to the application. More...
virtual void | docCharacters (const XMLCh *const chars, const XMLSize_t length, const bool cdataSection)
| Handle document character events. More...
virtual void | docComment (const XMLCh *const comment)
| Handle a document comment event. More...
virtual void | docPI (const XMLCh *const target, const XMLCh *const data)
| Handle a document PI event. More...
virtual void | endDocument ()
| Handle the end of document event. More...
virtual void | endElement (const XMLElementDecl &elemDecl, const unsigned int urlId, const bool isRoot, const XMLCh *const elemPrefix)
| Handle and end of element event. More...
virtual void | endEntityReference (const XMLEntityDecl &entDecl)
| Handle and end of entity reference event. More...
virtual void | ignorableWhitespace (const XMLCh *const chars, const XMLSize_t length, const bool cdataSection)
| Handle an ignorable whitespace vent. More...
virtual void | resetDocument ()
| Handle a document reset event. More...
virtual void | startDocument ()
| Handle a start document event. More...
virtual void | startElement (const XMLElementDecl &elemDecl, const unsigned int urlId, const XMLCh *const elemPrefix, const RefVectorOf< XMLAttr > &attrList, const XMLSize_t attrCount, const bool isEmpty, const bool isRoot)
| Handle a start element event. More...
virtual void | startEntityReference (const XMLEntityDecl &entDecl)
| Handle a start entity reference event. More...
virtual void | XMLDecl (const XMLCh *const versionStr, const XMLCh *const encodingStr, const XMLCh *const standaloneStr, const XMLCh *const actualEncStr)
| Handle an XMLDecl event. More...
virtual void | attDef (const DTDElementDecl &elemDecl, const DTDAttDef &attDef, const bool ignoring)
virtual void | doctypeComment (const XMLCh *const comment)
virtual void | doctypeDecl (const DTDElementDecl &elemDecl, const XMLCh *const publicId, const XMLCh *const systemId, const bool hasIntSubset, const bool hasExtSubset=false)
virtual void | doctypePI (const XMLCh *const target, const XMLCh *const data)
virtual void | doctypeWhitespace (const XMLCh *const chars, const XMLSize_t length)
virtual void | elementDecl (const DTDElementDecl &decl, const bool isIgnored)
virtual void | endAttList (const DTDElementDecl &elemDecl)
virtual void | endIntSubset ()
virtual void | endExtSubset ()
virtual void | entityDecl (const DTDEntityDecl &entityDecl, const bool isPEDecl, const bool isIgnored)
virtual void | resetDocType ()
virtual void | notationDecl (const XMLNotationDecl &notDecl, const bool isIgnored)
virtual void | startAttList (const DTDElementDecl &elemDecl)
virtual void | startIntSubset ()
virtual void | startExtSubset ()
virtual void | TextDecl (const XMLCh *const versionStr, const XMLCh *const encodingStr)
Public Member Functions inherited from XMemory
void * | operator new (size_t size)
| This method overrides operator new. More...
void * | operator new (size_t size, MemoryManager *memMgr)
| This method defines a custom operator new, that will use the provided memory manager to perform the allocation. More...
void * | operator new (size_t size, void *ptr)
| This method overrides placement operator new. More...
void | operator delete (void *p)
| This method overrides operator delete. More...
void | operator delete (void *p, MemoryManager *memMgr)
| This method provides a matching delete for the custom operator new. More...
void | operator delete (void *p, void *ptr)
| This method provides a matching delete for the placement new. More...
Public Member Functions inherited from XMLDocumentHandler
virtual | ~XMLDocumentHandler ()
Public Member Functions inherited from XMLErrorReporter
virtual | ~XMLErrorReporter ()
| Default destructor. More...
Public Member Functions inherited from XMLEntityHandler
virtual | ~XMLEntityHandler ()
| Default destructor. More...
Public Member Functions inherited from PSVIHandler
virtual | ~PSVIHandler ()

## Implementation of Grammar preparsing interface's.
Grammar * | loadGrammar (const InputSource &source, const Grammar::GrammarType grammarType, const bool toCache=false)
| Preparse schema grammar (XML Schema, DTD, etc.) via an input source object. More...
Grammar * | loadGrammar (const XMLCh *const systemId, const Grammar::GrammarType grammarType, const bool toCache=false)
| Preparse schema grammar (XML Schema, DTD, etc.) via a file path or URL. More...
Grammar * | loadGrammar (const char *const systemId, const Grammar::GrammarType grammarType, const bool toCache=false)
| Preparse schema grammar (XML Schema, DTD, etc.) via a file path or URL. More...
void | resetCachedGrammarPool ()
| This method allows the user to reset the pool of cached grammars. More...

## Additional Inherited Members
Public Types inherited from AbstractDOMParser
enum | ValSchemes { Val_Never , Val_Always , Val_Auto }
| ValScheme enum used in setValidationScheme Val_Never: Do not report validation errors. More...
Public Types inherited from XMLErrorReporter
enum | ErrTypes { ErrType_Warning , ErrType_Error , ErrType_Fatal , ErrTypes_Unknown }
Protected Member Functions inherited from AbstractDOMParser
| AbstractDOMParser (XMLValidator *const valToAdopt=0, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager, XMLGrammarPool *const gramPool=0)
| Construct a AbstractDOMParser, with an optional validator. More...
DOMNode * | getCurrentNode ()
| Get the current DOM node. More...
XMLScanner * | getScanner () const
| Get the XML scanner. More...
GrammarResolver * | getGrammarResolver () const
| Get the Grammar resolver. More...
bool | getParseInProgress () const
| Get the parse in progress flag. More...
MemoryManager * | getMemoryManager () const
void | setCurrentNode (DOMNode *toSet)
| Set the current DOM node. More...
void | setDocument (DOMDocument *toSet)
| Set the document node. More...
void | setParseInProgress (const bool toSet)
| Set the parse in progress flag. More...
void | resetPool ()
bool | isDocumentAdopted () const
| Returns true if the user has adopted the document. More...
virtual DOMCDATASection * | createCDATASection (const XMLCh *, XMLSize_t)
virtual DOMText * | createText (const XMLCh *, XMLSize_t)
virtual DOMElement * | createElement (const XMLCh *name)
virtual DOMElement * | createElementNS (const XMLCh *namespaceURI, const XMLCh *elemPrefix, const XMLCh *localName, const XMLCh *qName)
virtual DOMAttr * | createAttr (const XMLCh *name)
virtual DOMAttr * | createAttrNS (const XMLCh *namespaceURI, const XMLCh *elemPrefix, const XMLCh *localName, const XMLCh *qName)
Protected Member Functions inherited from XMemory
| XMemory ()
| Protected default constructor. More...
Protected Member Functions inherited from XMLDocumentHandler
| XMLDocumentHandler ()
Protected Member Functions inherited from XMLErrorReporter
| XMLErrorReporter ()
| Default constructor. More...
Protected Member Functions inherited from XMLEntityHandler
| XMLEntityHandler ()
| Protected default constructor. More...
Protected Member Functions inherited from PSVIHandler
| PSVIHandler ()
Protected Attributes inherited from AbstractDOMParser
bool | fCreateEntityReferenceNodes
bool | fIncludeIgnorableWhitespace
bool | fWithinElement
bool | fParseInProgress
bool | fCreateCommentNodes
bool | fDocumentAdoptedByUser
bool | fCreateSchemaInfo
bool | fDoXInclude
XMLScanner * | fScanner
XMLCh * | fImplementationFeatures
DOMNode * | fCurrentParent
DOMNode * | fCurrentNode
DOMEntityImpl * | fCurrentEntity
DOMDocumentImpl * | fDocument
DOMDocumentTypeImpl * | fDocumentType
RefVectorOf< DOMDocumentImpl > * | fDocumentVector
GrammarResolver * | fGrammarResolver
XMLStringPool * | fURIStringPool
XMLValidator * | fValidator
MemoryManager * | fMemoryManager
XMLGrammarPool * | fGrammarPool
XMLBufferMgr | fBufMgr
XMLBuffer & | fInternalSubset
PSVIHandler * | fPSVIHandler

## Detailed Description

This class implements the Document Object Model (DOM) interface.

It should be used by applications which choose to parse and process the XML document using the DOM api's. This implementation also allows the applications to install an error and an entity handler (useful extensions to the DOM specification).

It can be used to instantiate a validating or non-validating parser, by setting a member flag.

## Constructor & Destructor Documentation

## ◆ XercesDOMParser()

XercesDOMParser::XercesDOMParser | ( | XMLValidator *const | valToAdopt = `0`,
|  | MemoryManager *const | manager = `XMLPlatformUtils::fgMemoryManager`,
|  | XMLGrammarPool *const | gramPool = `0`
| ) |  |

Construct a XercesDOMParser, with an optional validator.

Constructor with an instance of validator class to use for validation. If you don't provide a validator, a default one will be created for you in the scanner.

Parameters

  gramPool | Pointer to the grammar pool instance from external application. The parser does NOT own it.
  valToAdopt | Pointer to the validator instance to use. The parser is responsible for freeing the memory.
  manager | Pointer to the memory manager to be used to allocate objects.

## ◆ ~XercesDOMParser()

virtual XercesDOMParser::~XercesDOMParser | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ cacheGrammarFromParse()

void XercesDOMParser::cacheGrammarFromParse | ( | const bool | newState | ) |

Set the 'Grammar caching' flag.

This method allows users to enable or disable caching of grammar when parsing XML documents. When set to true, the parser will cache the resulting grammar for use in subsequent parses.

If the flag is set to true, the 'Use cached grammar' flag will also be set to true.

The parser's default state is: false.

Parameters

  newState | The value specifying whether we should cache grammars or not.

See also
  isCachingGrammarFromParse
  useCachedGrammarInParse

## ◆ endInputSource()

void XercesDOMParser::endInputSource | ( | const InputSource & | inputSource | ) |
| virtual

Handle an end of input source event.

This method is used to indicate the end of parsing of an external entity file.

This method is a no-op for this DOM implementation.

Parameters

  inputSource | A const reference to the InputSource object which points to the XML file being parsed.

See also
  InputSource

Implements XMLEntityHandler.

## ◆ error()

virtual void XercesDOMParser::error | ( | const unsigned int | errCode,
|  | const XMLCh *const | msgDomain,
|  | const XMLErrorReporter::ErrTypes | errType,
|  | const XMLCh *const | errorText,
|  | const XMLCh *const | systemId,
|  | const XMLCh *const | publicId,
|  | const XMLFileLoc | lineNum,
|  | const XMLFileLoc | colNum
| ) |  |
| virtual

Handle errors reported from the parser.

This method is used to report back errors found while parsing the XML file. This method is also borrowed from the SAX specification. It calls the corresponding user installed Error Handler method: 'fatal', 'error', 'warning' depending on the severity of the error. This classification is defined by the XML specification.

Parameters

  errCode | An integer code for the error.
  msgDomain | A const pointer to an Unicode string representing the message domain to use.
  errType | An enumeration classifying the severity of the error.
  errorText | A const pointer to an Unicode string representing the text of the error message.
  systemId | A const pointer to an Unicode string representing the system id of the XML file where this error was discovered.
  publicId | A const pointer to an Unicode string representing the public id of the XML file where this error was discovered.
  lineNum | The line number where the error occurred.
  colNum | The column number where the error occurred.

See also
  ErrorHandler

Implements XMLErrorReporter.

## ◆ expandSystemId()

bool XercesDOMParser::expandSystemId | ( | const XMLCh *const | systemId,
|  | XMLBuffer & | toFill
| ) |  |
| virtual

Expand a system id.

This method allows an installed XMLEntityHandler to further process any system id's of external entities encountered in the XML file being parsed, such as redirection etc.

This method always returns 'false' for this DOM implementation.

Parameters

  systemId | A const pointer to an Unicode string representing the system id scanned by the parser.
  toFill | A pointer to a buffer in which the application processed system id is stored.

Returns
  'true', if any processing is done, 'false' otherwise.

Implements XMLEntityHandler.

## ◆ getEntityResolver() [1/2]

EntityResolver * XercesDOMParser::getEntityResolver | ( |  | ) |

Get a pointer to the entity resolver.

This method returns the installed entity resolver. If no resolver has been installed, then it will be a zero pointer.

Returns
  The pointer to the installed entity resolver object.

## ◆ getEntityResolver() [2/2]

const EntityResolver * XercesDOMParser::getEntityResolver | ( |  | ) | const

Get a const pointer to the entity resolver.

This method returns the installed entity resolver. If no resolver has been installed, then it will be a zero pointer.

Returns
  A const pointer to the installed entity resolver object.

## ◆ getErrorHandler() [1/2]

ErrorHandler * XercesDOMParser::getErrorHandler | ( |  | ) |

Get a pointer to the error handler.

This method returns the installed error handler. If no handler has been installed, then it will be a zero pointer.

Returns
  The pointer to the installed error handler object.

## ◆ getErrorHandler() [2/2]

const ErrorHandler * XercesDOMParser::getErrorHandler | ( |  | ) | const

Get a const pointer to the error handler.

This method returns the installed error handler. If no handler has been installed, then it will be a zero pointer.

Returns
  A const pointer to the installed error handler object.

## ◆ getGrammar()

Grammar * XercesDOMParser::getGrammar | ( | const XMLCh *const | nameSpaceKey | ) |

Retrieve the grammar that is associated with the specified namespace key.

Parameters

  nameSpaceKey | Namespace key

Returns
  Grammar associated with the Namespace key.

## ◆ getIgnoreCachedDTD()

bool XercesDOMParser::getIgnoreCachedDTD | ( |  | ) | const

Get the 'ignore cached DTD grammar' flag.

Returns
  true, if the parser is currently configured to ignore cached DTD, false otherwise.

See also
  setIgnoreCachedDTD

## ◆ getRootGrammar()

Grammar * XercesDOMParser::getRootGrammar | ( |  | ) |

Retrieve the grammar where the root element is declared.

Returns
  Grammar where root element declared

## ◆ getSrcOffset()

XMLFilePos XercesDOMParser::getSrcOffset | ( |  | ) | const

Returns the current src offset within the input source.

To be used only while parsing is in progress.

Returns
  offset within the input source

## ◆ getURIText()

const XMLCh * XercesDOMParser::getURIText | ( | unsigned int | uriId | ) | const

Returns the string corresponding to a URI id from the URI string pool.

Parameters

  uriId | id of the string in the URI string pool.

Returns
  URI string corresponding to the URI id.

## ◆ getXMLEntityResolver() [1/2]

XMLEntityResolver * XercesDOMParser::getXMLEntityResolver | ( |  | ) |

Get a pointer to the entity resolver.

This method returns the installed entity resolver. If no resolver has been installed, then it will be a zero pointer.

Returns
  The pointer to the installed entity resolver object.

## ◆ getXMLEntityResolver() [2/2]

const XMLEntityResolver * XercesDOMParser::getXMLEntityResolver | ( |  | ) | const

Get a const pointer to the entity resolver.

This method returns the installed entity resolver. If no resolver has been installed, then it will be a zero pointer.

Returns
  A const pointer to the installed entity resolver object.

## ◆ isCachingGrammarFromParse()

bool XercesDOMParser::isCachingGrammarFromParse | ( |  | ) | const

Get the 'Grammar caching' flag.

This method returns the state of the parser's grammar caching when parsing an XML document.

Returns
  true, if the parser is currently configured to cache grammars, false otherwise.

See also
  cacheGrammarFromParse

## ◆ isUsingCachedGrammarInParse()

bool XercesDOMParser::isUsingCachedGrammarInParse | ( |  | ) | const

Get the 'Use cached grammar' flag.

This method returns the state of the parser's use of cached grammar when parsing an XML document.

Returns
  true, if the parser is currently configured to use cached grammars, false otherwise.

See also
  useCachedGrammarInParse

## ◆ loadGrammar() [1/3]

Grammar * XercesDOMParser::loadGrammar | ( | const char *const | systemId,
|  | const Grammar::GrammarType | grammarType,
|  | const bool | toCache = `false`
| ) |  |

Preparse schema grammar (XML Schema, DTD, etc.) via a file path or URL.

This method invokes the preparsing process on a schema grammar XML file specified by the file path parameter. If the 'toCache' flag is enabled, the parser will cache the grammars for re-use. If a grammar key is found in the pool, no caching of any grammar will take place.

Parameters

  systemId | A const char pointer to a native string which contains the path to the XML grammar file to be preparsed.
  grammarType | The grammar type (Schema or DTD).
  toCache | If `true`, we cache the preparsed grammar, otherwise, no caching. Default is `false`.

Returns
  The preparsed schema grammar object (SchemaGrammar or DTDGrammar). That grammar object is owned by the parser.

Exceptions

  SAXException | Any SAX exception, possibly wrapping another exception.
  XMLException | An exception from the parser or client handler code.
  DOMException | A DOM exception as per DOM spec.

## ◆ loadGrammar() [2/3]

Grammar * XercesDOMParser::loadGrammar | ( | const InputSource & | source,
|  | const Grammar::GrammarType | grammarType,
|  | const bool | toCache = `false`
| ) |  |

Preparse schema grammar (XML Schema, DTD, etc.) via an input source object.

This method invokes the preparsing process on a schema grammar XML file specified by the SAX InputSource parameter. If the 'toCache' flag is enabled, the parser will cache the grammars for re-use. If a grammar key is found in the pool, no caching of any grammar will take place.

Parameters

  source | A const reference to the SAX InputSource object which points to the schema grammar file to be preparsed.
  grammarType | The grammar type (Schema or DTD).
  toCache | If `true`, we cache the preparsed grammar, otherwise, no caching. Default is `false`.

Returns
  The preparsed schema grammar object (SchemaGrammar or DTDGrammar). That grammar object is owned by the parser.

Exceptions

  SAXException | Any SAX exception, possibly wrapping another exception.
  XMLException | An exception from the parser or client handler code.
  DOMException | A DOM exception as per DOM spec.

See also
  InputSource::InputSource

## ◆ loadGrammar() [3/3]

Grammar * XercesDOMParser::loadGrammar | ( | const XMLCh *const | systemId,
|  | const Grammar::GrammarType | grammarType,
|  | const bool | toCache = `false`
| ) |  |

Preparse schema grammar (XML Schema, DTD, etc.) via a file path or URL.

This method invokes the preparsing process on a schema grammar XML file specified by the file path parameter. If the 'toCache' flag is enabled, the parser will cache the grammars for re-use. If a grammar key is found in the pool, no caching of any grammar will take place.

Parameters

  systemId | A const XMLCh pointer to the Unicode string which contains the path to the XML grammar file to be preparsed.
  grammarType | The grammar type (Schema or DTD).
  toCache | If `true`, we cache the preparsed grammar, otherwise, no caching. Default is `false`.

Returns
  The preparsed schema grammar object (SchemaGrammar or DTDGrammar). That grammar object is owned by the parser.

Exceptions

  SAXException | Any SAX exception, possibly wrapping another exception.
  XMLException | An exception from the parser or client handler code.
  DOMException | A DOM exception as per DOM spec.

## ◆ resetCachedGrammarPool()

void XercesDOMParser::resetCachedGrammarPool | ( |  | ) |

This method allows the user to reset the pool of cached grammars.

## ◆ resetDocumentPool()

void XercesDOMParser::resetDocumentPool | ( |  | ) |

Reset the documents vector pool and release all the associated memory back to the system.

When parsing a document using a DOM parser, all memory allocated for a DOM tree is associated to the DOM document.

If you do multiple parse using the same DOM parser instance, then multiple DOM documents will be generated and saved in a vector pool. All these documents (and thus all the allocated memory) won't be deleted until the parser instance is destroyed.

If you don't need these DOM documents anymore and don't want to destroy the DOM parser instance at this moment, then you can call this method to reset the document vector pool and release all the allocated memory back to the system.

It is an error to call this method if you are in the middle of a parse (e.g. in the mid of a progressive parse).

Exceptions

  IOException | An exception from the parser if this function is called when a parse is in progress.

## ◆ resetEntities()

void XercesDOMParser::resetEntities | ( |  | ) |
| virtual

Reset any entity handler information.

This method allows the installed XMLEntityHandler to reset itself.

This method is a no-op for this DOM implementation.

Implements XMLEntityHandler.

## ◆ resetErrors()

virtual void XercesDOMParser::resetErrors | ( |  | ) |
| virtual

Reset any error data before a new parse.

This method allows the user installed Error Handler callback to 'reset' itself.

This method is a no-op for this DOM implementation.

Implements XMLErrorReporter.

## ◆ resolveEntity()

virtual InputSource * XercesDOMParser::resolveEntity | ( | XMLResourceIdentifier * | resourceIdentifier | ) |
| virtual

Resolve a public/system id.

This method allows a user installed entity handler to further process any pointers to external entities. The applications can implement 'redirection' via this callback.

Parameters

  resourceIdentifier | An object containing the type of resource to be resolved and the associated data members corresponding to this type.

Returns
  The value returned by the user installed resolveEntity method or NULL otherwise to indicate no processing was done. The returned InputSource is owned by the parser which is responsible to clean up the memory.

See also
  XMLEntityHandler
  XMLEntityResolver

Implements XMLEntityHandler.

## ◆ setEntityResolver()

void XercesDOMParser::setEntityResolver | ( | EntityResolver *const | handler | ) |

Set the entity resolver.

This method allows applications to install their own entity resolver. By installing an entity resolver, the applications can trap and potentially redirect references to external entities.

Any previously set entity resolver is merely dropped, since the parser does not own them. If both setEntityResolver and setXMLEntityResolver are called, then the last one is used.

Parameters

  handler | A const pointer to the user supplied entity resolver.

See also
  getEntityResolver

## ◆ setErrorHandler()

void XercesDOMParser::setErrorHandler | ( | ErrorHandler *const | handler | ) |

Set the error handler.

This method allows applications to install their own error handler to trap error and warning messages.

Any previously set handler is merely dropped, since the parser does not own them.

Parameters

  handler | A const pointer to the user supplied error handler.

See also
  getErrorHandler

## ◆ setIgnoreCachedDTD()

void XercesDOMParser::setIgnoreCachedDTD | ( | const bool | newValue | ) |

Set the 'ignore cached DTD grammar' flag.

This method gives users the option to ignore a cached DTD grammar, when an XML document contains both an internal and external DTD, and the use cached grammar from parse option is enabled. Currently, we do not allow using cached DTD grammar when an internal subset is present in the document. This option will only affect the behavior of the parser when an internal and external DTD both exist in a document (i.e. no effect if document has no internal subset).

The parser's default state is false

Parameters

  newValue | The state to set

## ◆ setXMLEntityResolver()

void XercesDOMParser::setXMLEntityResolver | ( | XMLEntityResolver *const | handler | ) |

Set the entity resolver.

This method allows applications to install their own entity resolver. By installing an entity resolver, the applications can trap and potentially redirect references to external entities.

Any previously set entity resolver is merely dropped, since the parser does not own them. If both setEntityResolver and setXMLEntityResolver are called, then the last one set is used.

Parameters

  handler | A const pointer to the user supplied entity resolver.

See also
  getXMLEntityResolver

## ◆ startInputSource()

void XercesDOMParser::startInputSource | ( | const InputSource & | inputSource | ) |
| virtual

Handle a 'start input source' event.

This method is used to indicate the start of parsing an external entity file.

This method is a no-op for this DOM parse implementation.

Parameters

  inputSource | A const reference to the InputSource object which points to the external entity being parsed.

Implements XMLEntityHandler.

## ◆ useCachedGrammarInParse()

void XercesDOMParser::useCachedGrammarInParse | ( | const bool | newState | ) |

Set the 'Use cached grammar' flag.

This method allows users to enable or disable the use of cached grammars. When set to true, the parser will use the cached grammar, instead of building the grammar from scratch, to validate XML documents.

If the 'Grammar caching' flag is set to true, this method ignore the value passed in.

The parser's default state is: false.

Parameters

  newState | The value specifying whether we should use the cached grammar or not.

See also
  isUsingCachedGrammarInParse
  cacheGrammarFromParse

The documentation for this class was generated from the following file:

- XercesDOMParser.hpp